; Real Time Clock (IRQ 8) handler
;
; MC146818A

; Ports:
addr	equ	0x70	;Address select (w)
data	equ	0x71	;Data register (r/w)


%macro read_reg 1	; read_reg <register>
	mov	al, %1
	call	_read_reg
	add	esp, 4
%endmacro

_read_reg:
	call	select_reg
	in	al, data
	popf
	ret

%macro write_reg 2	; write_reg <register>, <value>
	mov	ax, %1 + (%2 << 8)
	call	_write_reg
	add	esp, 8
%endmacro


_write_reg:
	call	select_reg
	mov	al, ah
	out	data, al
	popf
	ret

select_reg:
	pushf
	cli
	out	addr, al
	jmp short $+2
	jmp short $+2
	jmp short $+2
	ret
