WORDLIST        ;( -- wid , Create a new wordlist )
        mov     edi, [_DSP]     ; wid = HERE
        mov     [edi], cell 0
        add     cell [_DSP], CELLSIZE
        upsh    edi
        ret
end WORDLIST



GET_ORDER       ;( -- widn ... wid1 n , Get search order )
        push    eax
        push    ecx
        push    esi

        mov     ecx, [num_wordlists]
        mov     esi, dict
.loop
        mov     eax, [esi]
        upsh    eax
        loop    .loop

        mov     eax, [num_wordlists]
        upsh    eax

        pop     esi
        pop     ecx
        pop     eax
        ret
end GET_ORDER



EVALUATE        ;( i*x c-addr u -- j*x , Interpret from a string )
        push    eax
        push    cell [_BLK]
        push    cell [_SOURCE_ID]
        push    cell [_INBUF]
        push    cell [_INBUF_LEN]
        push    cell [_TO_IN]

        mov     [_BLK], cell 0
        mov     [_SOURCE_ID], cell -1
        upop    eax
        mov     [_INBUF_LEN], eax
        upop    eax
        mov     [_INBUF], eax
        mov     [_TO_IN], cell 0
        call    PARSE_INBUF

        pop     cell [_TO_IN]
        pop     cell [_INBUF_LEN]
        pop     cell [_INBUF]
        pop     cell [_SOURCE_ID]
        pop     cell [_BLK]
        pop     eax
        ret
end EVALUATE



BYE
        mov     ax,0xffff
        int     0xE6
        hlt
end BYE



PARSE   ;( char "ccc<char>" -- c-addr u , parse until <char> is reached )
        push    eax
        push    ebx
        push    edx
        push    esi

        upop    edx                     ;DL = delimiter char

        mov     ebx, [_INBUF]
        add     ebx, [_TO_IN]
        upsh    ebx                     ;Push address

        mov     eax, [_INBUF_LEN]
        sub     eax, [_TO_IN]

        ;Find length
        sub     esi, esi
.length
        cmp     esi, eax                ;End of command line reached?
        jae     .end
        cmp     [ebx+esi], dl
        je      .end
        inc     esi
        jmp     .length

.end
        upsh    esi                     ;Push length
        inc     esi
        add     [_TO_IN], esi

        pop     esi
        pop     edx
        pop     ebx
        pop     eax
        ret
end PARSE



ALLOT   ;( n -- , (de)allocate data-space [add n to DSP] )
        push    eax
        upop    eax
        add     [_DSP], eax
        pop     eax
        ret
end ALLOT



CHAR_PLUS       ; CHAR+ ( addr1 -- addr2 , add the size of 1 char to addr1 )
        inc     cell tosreg
        ret
end CHAR_PLUS



CELL_PLUS       ; CELL+ ( addr1 -- addr2 , add the size of 1 cell to addr1 )
        add     cell tosreg, CELLSIZE
        ret
end CELL_PLUS



_CMOVE  ;( c-addr1 c-addr2 u -- , copy u chars from c-addr1 to c-addr2 )
        push    ecx
        push    esi
        push    edi

        mov     cx, ds
        mov     es, cx
        upop    ecx
        upop    edi
        upop    esi
        rep     movsb

        pop     edi
        pop     esi
        pop     ecx
        ret
end _CMOVE



HERE
        push    eax
        mov     eax, [_DSP]
        upsh    eax
        pop     eax
        ret
end HERE



FETCH   ; @ ( a-addr -- x , fetch x from a-addr )
        push    ebx

        upop    ebx
        mov     ebx, [ebx]
        upsh    ebx

        pop     ebx
        ret
end FETCH



STORE   ; ! ( x a-addr -- , store x at a-addr )
        push    eax
        push    ebx

        upop    ebx
        upop    eax
        mov     [ebx], eax

        pop     ebx
        pop     eax
        ret
end STORE



C_FETCH   ; @ ( c-addr -- char , fetch char from c-addr )
        push    ebx

        upop    ebx
        movsx   ebx, byte [ebx]
        upsh    ebx

        pop     ebx
        ret
end C_FETCH



C_STORE   ; ! ( char c-addr -- , store char at c-addr )
        push    eax
        push    ebx

        upop    ebx
        upop    eax
        mov     [ebx], al

        pop     ebx
        pop     eax
        ret
end C_STORE



PAGE
;
; This doesn't work right, at least not with more than 25 display lines
;
        mov     ah, 0x06        ; Int 10 service 6
        mov     al, 0x00        ; # of lines (0=clear screen)
        mov     bh, 7           ; Attribute
        mov     cx, 0
        mov     dh, 24
        mov     dl, 79
        int     0x10

        ret
end PAGE



AT_XY
        push    eax
        push    ebx
        push    edx

        upop    eax             ;Y
        upop    edx             ;X
        mov     dh, al
;        mov     dh, dl
;        mov     dl, al
        mov     ah, 0x02        ;Int 10 service 2
        mov     bh, 0           ;Page 0
        int     0x10

        pop     edx
        pop     ebx
        pop     eax
        ret
end AT_XY



hang
        jmp     hang


